-- P_BlockingWall: script by fickleheart
local tester = nil -- Misc object used for testing
rawset(_G, "P_BlockingWall", function(mobj, angle, maxdist, bust)
	
    if not (tester and tester.valid) then -- Spawn a new one!
        tester = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_GARGOYLE) -- Has the best chance of not getting cleared on spawn
        tester.flags = MF_NOGRAVITY|MF_NOCLIPTHING -- Make sure it won't move or block things
        tester.flags2 = $1|MF2_DONTDRAW -- Don't see the gargoyle! (can be commented out for testing if needed)
    end
	
	if bust
		tester.bust = true
	else
		tester.bust = false
	end
    
    -- Match tester size to mobj size
    tester.radius = mobj.radius
    tester.height = mobj.height
    
    P_SetOrigin(tester, mobj.x, mobj.y, mobj.z) -- Move tester to mobj's position
    P_InstaThrust(tester, angle, maxdist) -- Misuse P_InstaThrust to easily get the distance to move
    return not P_TryMove(tester, tester.x+tester.momx, tester.y+tester.momy, true) -- Return the inverse of P_TryMove (since it returns true on successful move, false on blocked)
end)

rawset(_G, "P_TestPosition", function(x,y,z,radius,height)
	if not (tester and tester.valid) then -- Spawn a new one!
        tester = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_GARGOYLE) -- Has the best chance of not getting cleared on spawn
        tester.flags = MF_NOGRAVITY|MF_NOCLIPTHING -- Make sure it won't move or block things
        tester.flags2 = $1|MF2_DONTDRAW -- Don't see the gargoyle! (can be commented out for testing if needed)
    end
	
	
	//Give it the specified size
	tester.radius = radius
	tester.height = height
	
	P_SetOrigin(tester, x, y, z) //Move it to the position that needs to be tested
	return tester
end)

addHook("MobjLineCollide",function(mo,line)
	if mo == tester
	and mo.bust
		if (line.frontsector == nil
		or (mo.z > line.frontsector.floorheight
		and mo.z + mo.height < line.frontsector.ceilingheight))
		and (line.backsector == nil
		or (mo.z > line.backsector.floorheight
		and mo.z + mo.height < line.backsector.ceilingheight))
			local returning = nil
			
			if line.frontsector
				for fof in line.frontsector.ffloors()
					if mo.z > fof.bottomheight
					and mo.z + mo.height < fof.topheight
					and fof.flags & FF_BUSTUP
						returning = false
					end
				end
			end
			
			if line.backsector
				for fof in line.backsector.ffloors()
					if mo.z > fof.bottomheight
					and mo.z + mo.height < fof.topheight
					and fof.flags & FF_BUSTUP
						returning = false
					end
				end
			end
			
			return returning
		end
	end
end, MT_GARGOYLE)