if srb2p
	return end

freeslot("SPR_RSNT","S_RUBYSENTRY_SPAWN","S_RUBYSENTRY_XDIE","S_RUBYSENTRY_IDLE","S_RUBYSENTRY_ATTACK","S_RUBYSENTRY_PAIN","MT_RUBYSENTRY","S_RUBYTARGET","MT_RUBYTARGET","sfx_infsmn")

local A_RubyRetaliate = function(actor,var1,var2)
	actor.refiretime = -1
	actor.target = nil
	S_StopSound(actor)
	S_StartSound(actor,actor.info.painsound)
end

local A_RubyXDeathSound = function(actor,var1,var2)
	S_StartSound(actor.subsector.sector,actor.info.activesound)
	S_StartSound(nil,actor.info.activesound,actor.tracer.player)
end

states[S_RUBYSENTRY_SPAWN] = {
	sprite = SPR_RSNT,
	frame = E|FF_ANIMATE|FF_TRANS50,
	var1 = 4,
	var2 = 2,
	tics = 8,
	nextstate = S_RUBYSENTRY_IDLE
}

states[S_RUBYSENTRY_XDIE] = {
	sprite = SPR_RSNT,
	frame = I|FF_ANIMATE,
	action = A_RubyXDeathSound,
	var1 = 3,
	var2 = 2,
	tics = 6,
	nextstate = S_NULL
}

states[S_RUBYSENTRY_IDLE] = {
	sprite = SPR_RSNT,
	frame = A|FF_ANIMATE,
	var1 = 3,
	var2 = 5,
	tics = -1
}

states[S_RUBYSENTRY_ATTACK] = {
	sprite = SPR_RSNT,
	frame = A,
	tics = -1,
	action = A_PlaySeeSound
}

states[S_RUBYSENTRY_PAIN] = {
	sprite = SPR_RSNT,
	frame = I,
	tics = TICRATE/2,
	nextstate = S_RUBYSENTRY_IDLE,
	action = A_RubyRetaliate
}

states[S_RUBYTARGET] = {
	sprite = SPR_RSNT,
	frame = M|FF_TRANS50,
	tics = 2,
	nextstate = S_NULL
}

mobjinfo[MT_RUBYSENTRY] = {
	spawnstate = S_RUBYSENTRY_SPAWN,
	spawnhealth = 2,
	deathstate = S_XPLD1,
	deathsound = sfx_pop,
	xdeathstate = S_RUBYSENTRY_XDIE,
	painstate = S_RUBYSENTRY_PAIN,
	painsound = sfx_dmpain,
	seesound = sfx_s3k9d,
	activesound = sfx_s3k9f,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_ENEMY|MF_SPECIAL|MF_SHOOTABLE,
	reactiontime = TICRATE*2
}

mobjinfo[MT_RUBYTARGET] = {
	spawnstate = S_RUBYTARGET,
	deathstate = S_NULL,
	radius = 0,
	height = 0,
	dispoffset = 3,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
}

addHook("MobjThinker",function(mo)
	if mo.health <= 0
	or mo.state == S_RUBYSENTRY_XDIE
		return end	
		
	if not (mo.tracer
	and mo.tracer.valid
	and mo.tracer.player
	and mo.tracer.player.sentry == mo
	and mo.tracer.player.playerstate == PST_LIVE
	and not mo.tracer.player.exiting
	and ~mo.eflags & MFE_GOOWATER)
	and mo.state != S_RUBYSENTRY_XDIE
		mo.state = S_RUBYSENTRY_XDIE
		return end

	local targz = mo.floorz + (64*FRACUNIT)
	if mo.eflags & MFE_VERTICALFLIP
		targz = mo.ceilingz - (96*FRACUNIT)
	end
	
	local speed = 4*FRACUNIT	
	
	if mo.z < targz-speed
		mo.z = $+speed
		mo.tics = 9
		mo.anim_duration = 2
		return
	elseif mo.z > targz+speed
		mo.z = $-speed
		mo.tics = 9
		mo.anim_duration = 2
		return
	else
		mo.z = targz
		if not mo.startedsound
			A_PlayActiveSound(mo)
			mo.startedsound = true
		end
	end
	
	if mo.state == S_RUBYSENTRY_SPAWN
		mo.refiretime = -mo.info.reactiontime
	end
	
	local range = 1000*FRACUNIT
	local tracer = nil
	searchBlockmap("objects",function(r,f)
		
		if r and f
		and r.valid and f.valid
		and R_PointToDist2(r.x,r.y,f.x,f.y) <= range
		and P_CheckSight(r,f)
		and (not (tracer and tracer.valid)
		or R_PointToDist2(r.x,r.y,f.x,f.y) < R_PointToDist2(r.x,r.y,tracer.x,tracer.y))
		and f != r.tracer
		and (not CBW_BATTLE
		or not CBW_Battle.MyTeam(r.tracer.player,f.player))
		and f.flags & (MF_ENEMY|MF_BOSS|MF_SHOOTABLE)
		and ~f.flags & MF_MONITOR
			tracer = f
		end
	end,mo,mo.x-(range),mo.x+(range),mo.y-(range),mo.y+(range))
	mo.target = tracer
	
	if tracer
	and tracer.valid
	and tracer.health > 0
	and mo.health > 0
	and R_PointToDist2(mo.x,mo.y,tracer.x,tracer.y) <= range
	and P_CheckSight(mo,tracer)
	and mo.refiretime > 0
		if mo.state == S_RUBYSENTRY_IDLE
			mo.state = S_RUBYSENTRY_ATTACK
		end
		mo.angle = R_PointToAngle2(mo.x,mo.y,tracer.x,tracer.y)
		local targ = P_SpawnMobj(tracer.x,tracer.y,tracer.z+(tracer.height/2),MT_RUBYTARGET)
		if targ and targ.valid
			targ.color = mo.color
		end
		for i = 1,9
			local dot = P_SpawnMobj(ease.linear(i*FRACUNIT/10,mo.x,tracer.x),ease.linear(i*FRACUNIT/10,mo.y,tracer.y),ease.linear(i*FRACUNIT/10,mo.z+(mo.height/2),tracer.z+(tracer.height/2)),MT_CYBRAKDEMON_TARGET_DOT)
			if dot and dot.valid
				dot.color = SKINCOLOR_RED
				dot.colorized = true
			end
		end
		mo.refiretime = $-1
		if mo.refiretime <= 0
			mo.refiretime = -mo.info.reactiontime
			P_DamageMobj(tracer,mo,mo.tracer,1)
			S_StartSound(tracer,sfx_inrbya,nil)
			for i = 1,99
			local cube = P_SpawnMobj(ease.linear(i*FRACUNIT/100,mo.x,tracer.x),ease.linear(i*FRACUNIT/100,mo.y,tracer.y),ease.linear(i*FRACUNIT/100,mo.z+(mo.height/2),tracer.z+(tracer.height/2)),MT_INFICUBE)
			if cube
			and cube.valid
				cube.scale = (FRACUNIT*3/2) - P_RandomFixed()
				cube.destscale = 0
				cube.momx = (P_RandomKey(10)*FRACUNIT/2)-(FRACUNIT*5/2)
				cube.momy = (P_RandomKey(10)*FRACUNIT/2)-(FRACUNIT*5/2)
				cube.momz = (P_RandomKey(10)*FRACUNIT/2)-(FRACUNIT*5/2)
				cube.color = mo.color
			end
		end
		end
	else
		mo.target = nil
		if mo.state != S_RUBYSENTRY_PAIN
			mo.flags2 = $&~MF2_FRET
			if mo.refiretime < 0
				mo.refiretime = $+1
			else
				mo.refiretime = mo.info.reactiontime
			end
		end
		if mo.state == S_RUBYSENTRY_ATTACK
			mo.state = S_RUBYSENTRY_IDLE
			S_StopSound(mo)
		end
	end
end,MT_RUBYSENTRY)

addHook("MobjSpawn",function(mo)
	mo.refiretime = mo.info.reactiontime
	mo.fuse = 30*TICRATE
end,MT_RUBYSENTRY)

addHook("ShouldDamage",function(t,i,s,d,dt)
	if t and i
	and i.type == MT_RUBYSENTRY
	and (not i.tracer
	or CBW_Battle.MyTeam(i.tracer.player,t.player))
		return false end
end,MT_PLAYER)

addHook("ShouldDamage",function(t,i,s,d,dt)
	if t and s
	and s.player
	and t.tracer
	and CBW_Battle.MyTeam(t.tracer.player,s.player)
		return false end
end,MT_RUBYSENTRY)

local battled = false

addHook("ThinkFrame",function()
	if CBW_Battle
	and not battled
		print("Adding Infinite BattleMod")
		battled = true
		local btl = CBW_Battle
		local InfiniteBattleAction = function(mo,doaction)
			local p = mo.player
			
			p.actiontext = "Phantom Sentry"
			p.actionrings = 15
			p.action2text = nil
			p.action2rings = 0
			
			if doaction == 1
				if P_BlockingWall(p.mo,p.mo.angle,100*FRACUNIT,false)
					S_StartSound(nil,sfx_s3k8c,p)
					return end
					
				local tester = P_TestPosition(p.mo.x+(100*cos(p.mo.angle)),p.mo.y+(100*sin(p.mo.angle)),p.mo.floorz,16*FRACUNIT,FRACUNIT)
				if p.mo.eflags & MFE_VERTICALFLIP
					tester.z = tester.ceilingz
				else
					tester.z = tester.floorz+10*FRACUNIT
				end
				
				if tester.eflags & (MFE_GOOWATER|MFE_TOUCHLAVA)
				or P_IsObjectInGoop(tester)
				or tester.subsector.sector.damagetype
				/*or (tester.ffloor 
				and (tester.ffloor.flags & FF_GOOWATER
				or P_CheckSolidLava(tester.ffloor)))*/
					S_StartSound(nil,sfx_s3k8c,p)
					return
				end
				
				local returning = false
				for fof in tester.subsector.sector.ffloors()
					if P_CheckSolidLava(tester,fof)
					or (fof.flags & FF_GOOWATER 
					and fof.flags & FF_SWIMMABLE)
					and not tester.floorrover
						returning = true
					end
				end
				
				for pobj in tester.subsector.polyList()
					if pobj:mobjInside(tester)
						returning = true
					end
				end
				
				if returning
					S_StartSound(nil,sfx_s3k8c,p)
					return end
					
				btl.PayRings(p)
				btl.ApplyCooldown(p,10*TICRATE,true)
				
				if p.sentry
				and p.sentry.valid
					P_GivePlayerRings(p,p.actionrings*p.sentry.fuse/(30*TICRATE))
					P_KillMobj(p.sentry)
				end
				
				p.sentry = P_SpawnMobj(p.mo.x+(100*cos(p.mo.angle)),p.mo.y+(100*sin(p.mo.angle)),p.mo.floorz,MT_RUBYSENTRY)
				if p.mo.eflags & MFE_VERTICALFLIP
					p.sentry.z = p.mo.ceilingz
				end
				p.sentry.angle = p.mo.angle
				p.sentry.tracer = p.mo
				p.sentry.color = p.mo.color
				p.sentry.eflags = p.mo.eflags
				
				p.mo.state = S_PLAY_FIRE
				P_InstaThrust(p.mo,0,0)
				p.drawangle = p.mo.angle
				S_StartSound(p.mo,sfx_infsmn)
			end
		end
	
		local infiniteExhaust = function(p)
			if p.weapondelay == TICRATE-1
				p.exhaustmeter = max(0,$-FRACUNIT/3)
			elseif p.weapondelay == 0
			or p.weapondelay > 1800*TICRATE
				p.exhaustmeter = min(FRACUNIT,$+FRACUNIT/(TICRATE*5))
			end
			
			if p.exhaustmeter == 0
			and not p.exhausted
				p.exhausted = true
				p.weapondelay = 3600*TICRATE
				S_StartSound(p.mo,sfx_kc65)
			elseif p.exhaustmeter == FRACUNIT
			and p.exhausted
				p.exhausted = false
				p.weapondelay = TICRATE
				S_StartSound(p.mo,sfx_kc5a)
			end
			return true
		end
	
		btl.SkinVars["infinite"] = {		
			weight = 100,
			flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD,
			special = InfiniteBattleAction,
			func_exhaust = infiniteExhaust
		}
	end
end)

addHook("PostThinkFrame",function()
	for p in players.iterate
		local mo = p.mo
		if mo and mo.valid
		and mo.skin == "infinite"
		and CBW_Battle
			if p.exhausted
				mo.colorized = not $
				p.exhaustedflash = true
				if not p.team
					mo.color = SKINCOLOR_CARBON
				end
			elseif p.exhaustedflash
				mo.colorized = false
				p.exhaustedflash = nil
				mo.color = p.skincolor
			end
		end
	end
end)