/* 	--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**	Infinite
**	Character owned by Sonic Team (whether they like it or not)
**	Code (mostly) by PikaJade
**	Model by Sonic Team
**	Animations, rendering, and processing by PikaJade
**	Have fun!
*/	--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

//Whole lotta freeslots
freeslot(
	"SPR_INCB",
	"S_PLAY_INFITP",
	"S_PLAY_INFIMELEE",
	"S_PLAY_INFIMELEE_FINISH",
	"S_PLAY_WINFINITE",
	"S_PLAY_WINFINISH",
	"S_PLAY_INFITAUNT",
	"S_PLAY_INFITAUNT_FINISH",
	"S_PLAY_INFITURN",
	"S_INFISNAKE",
	"S_INFISNAKE_XPLD",
	"S_INFICUBE",
	"MT_INFISNAKE",
	"MT_INFICUBE",
	"SKINCOLOR_SUPER_OVERCLOCK_1",
	"SKINCOLOR_SUPER_OVERCLOCK_2",
	"SKINCOLOR_SUPER_OVERCLOCK_3",
	"SKINCOLOR_SUPER_OVERCLOCK_4",
	"SKINCOLOR_SUPER_OVERCLOCK_5",
	"sfx_infpna",
	"sfx_infpnb",
	"sfx_infpnc",
	"sfx_winfia",
	"sfx_winfib",
	"sfx_winfic",
	"sfx_infata",
	"sfx_infatb",
	"sfx_infatc",
	"sfx_ibsrta",
	"sfx_ibsrtb",
	"sfx_ibsrtc",
	"sfx_ibwina",
	"sfx_ibwinb",
	"sfx_ibwinc",
	"sfx_ipncha",
	"sfx_ipnchb",
	"sfx_ipnchc",
	"sfx_inrbya",
	"sfx_inrbyb",
	"sfx_inrbyc",
	"sfx_infitp",
	"sfx_inffly",
	"sfx_voxoff",
	"sfx_voxon",
	"sfx_voxlol",
	"sfx_inload",
	"sfx_idilol",
	"sfx_infjmp",
	"sfx_inftrg"
)

S_StartSound(nil,sfx_inload) //I am Infinite!
if srb2p
	return end

//The initial state of the Infinite variable table
local infinitialize = function(p)
	p.infinite = {
		victorytaunt = false, // Whether or not Infinite has played his victory voiceline
		flightresolved = 0, // State of the Hover Dash
		flighttimer = 0, // How much longer the Hover Dash will last for
		prethinkthrust = 0, // To counteract player controls during the Hover Dash
		lastnearest = nil, // The object targeted for a Homing Snap last frame
		snapleniency = 0, // The extra leniency to performing a Homing Snap after the Hover Dash end
		lastbuttons = 0, // Whether or not the Spin button was pressed last frame
		starttaunt = -1, // How long until Infinite taunts the boss at the start of the level
		manualtaunted = false, // Whether or not Infinite taunted with Toss Flag, thus making his important voice lines interruptible
		prevdrawangle = 0 // AngleStand spoof
	}
end

// Change function for infinitemute
local shutUpInfinite = function(var)
	if var.value == 2
		print("Infinite will play too many voice lines","(WARNING: This setting causes some pretty noticeable jank! Nothing serious, but not exactly subtle, either. Proceed with caution!)")
		S_StartSound(nil,sfx_voxlol)
	elseif var.value == 3
		print("Infinite will play some voice lines")
		S_StartSound(nil,sfx_voxon)
	elseif var.value
		print("Infinite will not play voice lines")
		S_StartSound(nil,sfx_voxoff)
	else
		print("Infinite will play voice lines")
		S_StartSound(nil,sfx_voxon)
	end
end

local novoice = CV_RegisterVar({name = "infinitevox", defaultvalue = "On", flags = CV_NETVAR|CV_NOINIT|CV_CALL, possiblevalue = {Off = 1, On = 0, LOL = 2, Some = 3}, func = shutUpInfinite})

// Random voice events

// Getting hurt
local hurtvox = {
	sfx_infpna,
	sfx_infpnb,
	sfx_infpnc
}

// Using Tidal Wave or Homing Snap
local atkvox = {
	sfx_infata,
	sfx_infatb,
	sfx_infatc
}

// Beating a level
local levelwin = {
	sfx_winfia,
	sfx_winfib,
	sfx_winfic
}

// Starting a boss
local bosstaunt = {
	sfx_ibsrta,
	sfx_ibsrtb,
	sfx_ibsrtc
}

// Bringing a boss down to their pinch phase
local bosspinch = {
	sfx_ipncha,
	sfx_ipnchb,
	sfx_ipnchc
}

// Defeating a boss
local bosswin = {
	sfx_ibwina,
	sfx_ibwinb,
	sfx_ibwinc
}

// Taunting using Toss Flag
local manualtaunt = {
	sfx_ibsrta,
	sfx_ibsrtb,
	sfx_ibsrtc,
	sfx_ipnchc,
	sfx_winfic
}

// Tidal Wave (not voices)
local ruby = {
	sfx_inrbya,
	sfx_inrbyb,
	sfx_inrbyc
}

// Set up for A_InfiFade
local A_InfiFadeStart = function(mo,var1,var2)
	if mo.player
		mo.player.infifade = 2
	end
end

// Make Infinite transluscent for as long as A_InfiFadeStart set it up to; in this case, 2 calls of A_InfiFade
local A_InfiFade = function(mo,var1,var2)
	if mo.player
		if mo.player.infifade
			mo.player.infifade = $-1
			mo.frame = $|FF_TRANS50
		end
	end
end

// Make a snake explode
local A_ExplodeSnake = function(mo,a,b)
	local a = 256*mo.scale
	local count = 32
	local time = 8
	
	for i = 0,count
		local cube = P_SpawnMobj(mo.x,mo.y,mo.z,MT_INFICUBE)
		cube.scale = mo.scale
		cube.momx = 0
		cube.momy = 0
		cube.momz = 0
		
		local angle = P_RandomKey(360)*ANG1
		local aiming = P_RandomKey(360)*ANG1
		
		cube.tics = time
		
		P_InstaThrust(cube,angle,FixedMul(a/time,cos(aiming)))
		P_SetObjectMomZ(cube,FixedMul(a/(2*time),sin(aiming)))
	end
	
	mo.state = S_NULL
end

// States and object types
states[S_PLAY_INFITP] = // Beginning a Homing Snap
{
	sprite = SPR_NULL,
	tics = 4,
	nextstate = S_PLAY_INFIMELEE,
	action = A_InfiFadeStart
}

states[S_PLAY_WINFINITE] = // Victory taunt
{
	sprite = SPR_PLAY,
	frame = SPR2_GLID|FF_SPR2ENDSTATE,
	tics = 4,
	nextstate = S_PLAY_WINFINITE,
	var1 = S_PLAY_WINFINISH
}

states[S_PLAY_WINFINISH] = // Victory taunt end
{
	sprite = SPR_PLAY,
	frame = SPR2_LAND,
	tics = -1
}

states[S_PLAY_INFITAUNT] = // Manual taunt
{
	sprite = SPR_PLAY,
	frame = SPR2_FLY|FF_SPR2ENDSTATE,
	tics = 4,
	nextstate = S_PLAY_INFITAUNT,
	var1 = S_PLAY_INFITAUNT_FINISH
}

states[S_PLAY_INFITAUNT_FINISH] = // Manual taunt end
{
	sprite = SPR_PLAY,
	frame = SPR2_TIRE,
	tics = -1
}

states[S_PLAY_INFIMELEE] = // Homing Snap kick
{
	sprite = SPR_PLAY,
	frame = SPR2_MLEE|FF_SPR2ENDSTATE,
	tics = 2,
	nextstate = S_PLAY_INFIMELEE,
	var1 = S_PLAY_INFIMELEE_FINISH,
	action = A_InfiFade
}

states[S_PLAY_INFIMELEE_FINISH] = // Turning around after a Homing Snap
{
	sprite = SPR_PLAY,
	frame = SPR2_MLEL,
	tics = -1,
	nextstate = S_PLAY_FALL
}

states[S_PLAY_INFITURN] = // Turning around during a Hover Dash
{
	sprite = SPR_PLAY,
	frame = SPR2_SKID,
	tics = -1,
	nextstate = S_PLAY_FLOAT
}

states[S_INFISNAKE] = // The part of the Tidal Wave that actually executes all the logic and hurts stuff
{
	sprite = SPR_NULL,
	tics = TICRATE*2,
	nextstate = S_INFISNAKE_XPLD
}

states[S_INFISNAKE_XPLD] = // When a Tidal Wave hits a wall or enemy
{
	sprite = SPR_NULL,
	tics = 0,
	nextstate = S_NULL,
	action = A_ExplodeSnake
}

states[S_INFICUBE] = // Tidal Wave cube effects
{
	sprite = SPR_INCB,
	tics = TICRATE/2,
	nextstate = S_NULL
}

mobjinfo[MT_INFISNAKE] = // Tidal Wave core thinker
{
	spawnstate = S_INFISNAKE,
	spawnhealth = 100,
	deathstate = S_INFISNAKE_XPLD,
	speed = 10*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_MISSILE
}

mobjinfo[MT_INFICUBE] = // Tidal Wave cubes
{
	spawnstate = S_INFICUBE,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

// Overclocked supercolor
skincolors[SKINCOLOR_SUPER_OVERCLOCK_1] = {
	name = "SUPER OVERCLOCKED 1",
	ramp = {35, 35, 35, 35, 25, 26, 27, 27, 27, 28, 29, 29, 30, 30, 31, 31 },
	invcolor = SKINCOLOR_SUPERRED5,
	invshade = 9,
	chatcolor = V_INVERTMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER_OVERCLOCK_2] = {
	name = "SUPER OVERCLOCKED 2",
	ramp = {21, 22, 23, 24, 35, 35, 35, 35, 27, 28, 29, 29, 30, 30, 31, 31 },
	invcolor = SKINCOLOR_SUPERRED4,
	invshade = 9,
	chatcolor = V_INVERTMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER_OVERCLOCK_3] = {
	name = "SUPER OVERCLOCKED 3",
	ramp = {21, 22, 23, 24, 25, 26, 27, 27, 35, 35, 35, 35, 30, 30, 31, 31 },
	invcolor = SKINCOLOR_SUPERRED3,
	invshade = 9,
	chatcolor = V_INVERTMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER_OVERCLOCK_4] = {
	name = "SUPER OVERCLOCKED 4",
	ramp = {21, 22, 23, 24, 25, 26, 27, 27, 27, 28, 29, 29, 35, 35, 35, 35 },
	invcolor = SKINCOLOR_SUPERRED2,
	invshade = 9,
	chatcolor = V_INVERTMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER_OVERCLOCK_5] = {
	name = "SUPER OVERCLOCKED 5",
	ramp = {35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35 },
	invcolor = SKINCOLOR_SUPERRED1,
	invshade = 9,
	chatcolor = V_INVERTMAP,
	accessible = false
}

local getInputAngle = function(p)
	if p.mo and p.mo.valid
	and ((p.pflags & PF_ANALOGMODE) or (p.mo.flags2 & MF2_TWOD))
		return p.mo.angle
	end
	
	local cmd = p.cmd
	return (cmd.angleturn*FRACUNIT) + R_PointToAngle2(0,0,cmd.forwardmove*FRACUNIT,-cmd.sidemove*FRACUNIT)
end

local dotProduct2d = function(x1, y1, x2, y2)
	return fixmul(x1,x2) + fixmul(y1,y2)
end

// Stop Infinite's voice clips from playing
// Returns false if an important voice clip is playing that can't be stopped
local infiniteStopVoice = function(mo)
	
	// Can't stop a sound from something that doesn't exist
	if not mo
		return true
		
	// Manual taunt can be cancelled, despite playing otherwise important voice clips
	elseif mo.player
	and mo.player.infinite.manualtaunted
		mo.player.infinite.manualtaunted = false
		if (mo.state == S_PLAY_INFITAUNT
		or mo.state == S_PLAY_INFITAUNT_FINISH)
		and novoice.value != 2
			mo.state = S_PLAY_STND
		end
		
	//Don't interrupt important voice clips
	elseif (S_SoundPlaying(mo,sfx_ibsrta)
	or S_SoundPlaying(mo,sfx_ibsrtb)
	or S_SoundPlaying(mo,sfx_ibsrtc)
	or S_SoundPlaying(mo,sfx_ibwina)
	or S_SoundPlaying(mo,sfx_ibwinb)
	or S_SoundPlaying(mo,sfx_ibwinc)
	or S_SoundPlaying(mo,sfx_ipncha)
	or S_SoundPlaying(mo,sfx_ipnchb)
	or S_SoundPlaying(mo,sfx_ipnchc)
	or S_SoundPlaying(mo,sfx_winfia)
	or S_SoundPlaying(mo,sfx_winfib)
	or S_SoundPlaying(mo,sfx_winfic))
	and novoice.value != 2
		return false
	end
	
	// Stop all Infinite voice clips
	S_StopSoundByID(mo,sfx_ibsrta)
	S_StopSoundByID(mo,sfx_ibsrtb)
	S_StopSoundByID(mo,sfx_ibsrtc)
	S_StopSoundByID(mo,sfx_ibwina)
	S_StopSoundByID(mo,sfx_ibwinb)
	S_StopSoundByID(mo,sfx_ibwinc)
	S_StopSoundByID(mo,sfx_ipncha)
	S_StopSoundByID(mo,sfx_ipnchb)
	S_StopSoundByID(mo,sfx_ipnchc)
	S_StopSoundByID(mo,sfx_winfia)
	S_StopSoundByID(mo,sfx_winfib)
	S_StopSoundByID(mo,sfx_winfic)
	S_StopSoundByID(mo,sfx_infata)
	S_StopSoundByID(mo,sfx_infatb)
	S_StopSoundByID(mo,sfx_infatc)
	S_StopSoundByID(mo,sfx_infpna)
	S_StopSoundByID(mo,sfx_infpnb)
	S_StopSoundByID(mo,sfx_infpnc)
	return true
end

// Play a voice clip for Infinite
local infiniteVoice = function(mo,table)
	if novoice.value != 1
	and not (mo.player
	and (mo.player.powers[pw_carry] == CR_NIGHTSMODE // Thing get screwy in NiGHTs mode, so let's just not worry about it
	or mo.player.powers[pw_underwater] or mo.player.powers[pw_spacetime])) // Don't talk with your mouth full (of water) (or space)
	and infiniteStopVoice(mo) // Don't talk twice, or interrupt yourself
		local index
		// Weird way of selecting a random item, since the first randomization always seems to be 0? No clue why
		repeat  index = P_RandomKey(#table+1) until  index > 0
		return S_StartSoundAtVolume(mo,table[index],255)
	end
end

// Play a random sound off of the Phantom Ruby sound list
local infiniteRubySound = function(mo)
	return S_StartSound(mo,ruby[P_RandomKey(2)+1])
end

// Whether or not Infinite could perform a Homing Snap on a given target
local infiniteCanTarget = function(r,f,nearest,range)
	
	// Take note of the angle between Infinite and his target
	local objectdir = R_PointToAngle2(r.x,r.y,f.x,f.y)
	
	local rvec = {cos(r.angle),sin(r.angle)} // The vector of the player's facing direction
	local fvec = {cos(objectdir),sin(objectdir)} // The vector of the angle between Infinite and his target
			
	if f and r // Both must exist
	and not f.player // Cannot target players, because that would be awful to play against
	and R_PointToDist2(r.x,r.y,f.x,f.y) <= r.radius + f.radius + range // Horizontal distance between objects is within given range
	and abs(r.z-f.z) * 2 <= r.height + f.height + range // Vertical distance between objects is within given range
	and f.health // Target must not be dead
	and (f.flags & MF_SHOOTABLE // Must be shootable...
		or f.state == S_METALSONIC_FLOAT  // ...Metal Sonic (battle)...
		or f.type == MT_EGGSHIELD // ...an Egg Guard's shield...
		or (f.flags & MF_SPRING and R_PointToDist2(r.x,r.y,f.x,f.y) <= r.radius + f.radius + range/2)) // ...or a spring within half the given range range
	and not (f.flags2 & MF2_FRET) // Must not be invincible, to avoid cheesing bosses
	and (nearest == nil
	or R_PointToDist2(r.x,r.y,f.x,f.y) < R_PointToDist2(r.x,r.y,nearest.x,nearest.y)) // Closer than given existing target
	and not (r.player.sentry
	and r.player.sentry == f) // Cannot attack your own Ruby Sentry
	and f.type != MT_SNAILER // Snailers clip people into walls, don't mess with them
	and P_CheckSight(r,f) // Must be able to see
	and (f.ceilingz - f.floorz >= r.height // Infinite must be able to fit...
		or f.type == MT_EGGMOBILE3 or f.type == MT_FAKEMOBILE) // ...unless it's the Sea Egg, which is always getting smushed, apparently
	
	// Check to make sure the Sea Egg isn't clipping you into the floor
	and not ((f.type == MT_EGGMOBILE3
	or f.type == MT_FAKEMOBILE)
	and f.z + (f.height/2) <= r.floorz)
	
	// Check to make sure you're not trying to hit an Egg Colosseum that can't be hit
	and not (f.type == MT_EGGMOBILE4
	and not (f.movefactor and f.state != S_EGGMOBILE4_STND)
	and f.health > f.info.damage)
	
	and (dotProduct2d(fvec[1],fvec[2],rvec[1],rvec[2]) >= 0 // Crude dot product
	or R_PointToDist2(r.x,r.y,f.x,f.y) < range/4) // Bypass if close enough

		return true
		
	end
	return false
end

// Spawn targets for Infinite
local doInfiniteTarget = function(mo)
	local range = 250*mo.scale // Range of the attack
	local nearest // Existing target
	
	// Double the targeting radius while overclocked
	if mo.player.powers[pw_super] 
		range = $*2 
	end
	
	searchBlockmap("objects",function(r,f)
		if infiniteCanTarget(r,f,nearest,range)
			nearest = f
		end
	end,mo,mo.x-range,mo.x+range,mo.y-range,mo.y+range)
	
	if nearest
		P_SpawnLockOn(mo.player,nearest,S_LOCKON1)
		if nearest != mo.lastnearest
			mo.lastnearest = nearest
			S_StartSound(mo,sfx_inftrg)
		end
		
		return true
	end
	
	mo.lastnearest = nil
	return false
end

local doInfiniteAttack = function(mo)
	
	local range = 250*mo.scale
	local nearest
	
	// Double the targeting radius while overclocked
	if mo.player.powers[pw_super] 
		range = $*2 
	end
	
	searchBlockmap("objects",function(r,f)
		if infiniteCanTarget(r,f,nearest,range)
			nearest = f
		end
	end,mo,mo.x-range,mo.x+range,mo.y-range,mo.y+range)
	
	if nearest
		
		local p = mo.player
		
		//Use the appropriate state
		mo.state = S_PLAY_INFITP
		
		// Spawn an MT_THOK where Infinite was
		local start = P_SpawnMobj(mo.x,mo.y,mo.z,MT_RAY)
		
		local invec = {
			x = cos(getInputAngle(p)), 
			y = sin(getInputAngle(p))
		}
		local televec = {
			x = cos(R_PointToAngle2(mo.x,mo.y,nearest.x,nearest.y)),
			y = sin(R_PointToAngle2(mo.x,mo.y,nearest.x,nearest.y))
		}
	
		// Face towards the target
		p.drawangle = mo.angle + ANGLE_180
		p.infinite.prevdrawangle = p.drawangle // Make sure the AngleStand spoof doesn't immediately correct the angle
		
		// Make Infinite hurt stuff during the start of the attack
		p.powers[pw_strong] = STR_ATTACK|STR_SPRING|STR_SPIKE|STR_ANIM
	
		// Teleport to your target
		P_SetOrigin(mo,nearest.x,nearest.y,nearest.z+(nearest.height/2))
		
		// Make a trail
		if start.valid
			local stepCount = 64
			local step = {x = (mo.x-start.x)/64, y = (mo.y-start.y)/64, z = (mo.z-start.z)/64}
			for i = 0,stepCount
				local ghost = P_SpawnMobj(start.x + step.x*i, start.y + step.y*i, start.z + step.z*i, MT_THOK)
				if ghost.valid
					ghost.color = SKINCOLOR_RED
					ghost.colorized = true
					ghost.sprite = SPR_PLAY
					ghost.skin = "infinite"
					ghost.sprite2 = SPR2_MLEE
					ghost.alpha = FU/3
					ghost.tics = mo.tics
					ghost.scale = mo.scale * i / stepCount
				end
			end
		end
		
		// If you got hurt (somehow), cancel everything else
		// Mostly a leftover from previous versions, where the Homing Snap didn't give you invulnerability
		if p.pstate == PST_DEAD
		or P_PlayerInPain(p)
			return true end
			
		// Play an attack voice clip
		if not ((nearest.flags & MF_BOSS
		and nearest.info.damage
		and ((nearest.info.spawnhealth > 1) // If it's a boss with a pinch phase...
		and (nearest.health == nearest.info.damage
		or nearest.health == 0)) // ...and you triggered its pinch phase or killed it, don't bother
		) and novoice.value != 3) // If Infinite shouldn't taunt bosses, don't bother not bothering
			infiniteVoice(mo,atkvox) end
			
		// Adjust speed based on input
		local moveModifier = (dotProduct2d(invec.x,invec.y,televec.x,televec.y) + FU/2)*2/3
		
		// Automatically go flying away from the pre-pinch Egg Colosseum
		if nearest.type == MT_EGGMOBILE4
		and nearest.health >= nearest.info.damage
			moveModifier = -mo.scale
		end
		
		// Go flying forward (if you didn't hit a spring)
		if ~nearest.flags & MF_SPRING
			P_InstaThrust(mo,mo.angle,FixedMul(mo.player.actionspd,moveModifier))
			P_SetObjectMomZ(mo,mo.player.actionspd/5,false)
		end
		
		// Break Egg Guards' shields
		if nearest.type == MT_EGGSHIELD
			P_KillMobj(nearest,mo,mo)
			S_StartSound(nearest,sfx_wbreak)
		end
		
		// Slow down underwater (if you didn't hit a spring)
		if mo.eflags & MFE_UNDERWATER
		and ~nearest.flags & MF_SPRING
			mo.momx = $*2/3
			mo.momy = $*2/3
			mo.momz = $*2/3
		end
	
		// Fun fact: this sound effect is taken from Infinite's theme song!
		S_StartSoundAtVolume(mo,sfx_infitp,FRACUNIT*2/3)
		
		// Play the targeting sound, if it didn't get a chance to play before
		if not mo.lastnearest
			S_StartSound(mo,sfx_inftrg)
		end
		
		// Can't Homing Snap after Homing Snapping
		p.infinite.snapleniency = 0
		
		return true
		
	end
	return false
end

// Hover Dash logic
local doInfiniteFlight = function(p,mo)

	// Decrement the flight timer
	if not p.powers[pw_super]
		p.infinite.flighttimer = $-1
	end
	
	//The direction Infinite is moving in
	local thrustangle = R_PointToAngle2(0,0,mo.momx,mo.momy)
	
	// ...unless the game kept track of the direction he was moving in at the start of the frame, in which case we'll use that
	if p.infinite.prethinkthrust
		thrustangle = p.infinite.prethinkthrust
	end
	
	// Face the direction you're moving
	p.drawangle = thrustangle
	
	// You can still Homing Snap a bit after the Hover Dash ends naturally
	p.infinite.snapleniency = TICRATE/2
	
	// Do Homing Snap
	if p.cmd.buttons & BT_SPIN
	and not p.exiting
	and doInfiniteAttack(mo)
		return 3
		
	// Continue performing Hover Dash
	elseif p.cmd.buttons & BT_JUMP
	and not (p.exiting
	or p.powers[pw_nocontrol]
	or p.powers[pw_carry])
	and p.infinite.flighttimer > 0
		
		// Draw targets
		doInfiniteTarget(mo)
		
		// Use this bizarre value of pw_strong to make the game beatable. Thanks, DSZ2 and ACZ1!
		p.powers[pw_strong] = STR_GLIDE|STR_SPIKE|STR_WALL|STR_SPRING|STR_ANIM
		
		local top = FixedMul(p.actionspd,mo.scale)
		if mo.eflags & MFE_UNDERWATER // Go slower underwater
			top = $*4/9
		end
		if p.powers[pw_sneakers] or p.powers[pw_super] // Go faster with Speed Shoes
			top = $*8/5
		end
		
		// Accelerate if not already at top speed
		local thrust = min(FixedHypot(mo.momx,mo.momy)+mo.scale,top)
		local movingAngle = R_PointToAngle2(0,0,mo.momx,mo.momy)
		
		//P_InstaThrust(mo,angle,thrust)
		mo.momx = ($ + P_ReturnThrustX(mo,thrustangle,thrust))/2
		mo.momy = ($ + P_ReturnThrustY(mo,thrustangle,thrust))/2
		P_Thrust(mo,getInputAngle(p),mo.scale)
		P_InstaThrust(mo,movingAngle,min(FixedHypot(mo.momx,mo.momy),top))
		
		// The droop snoot. The snoot, droops.
		local droop = (TICRATE-p.infinite.flighttimer)/-6
		droop = min(0,$)
		
		// Droop up if in goop
		if P_IsObjectInGoop(mo)
			droop = -$ end
		
		P_SetObjectMomZ(mo,droop*FU,false)
		
		
			
		// If you're going fast or turning around, act like it
		if thrust >= top
			mo.state = S_PLAY_FLOAT_RUN
		elseif dotProduct2d(cos(movingAngle),sin(movingAngle), cos(getInputAngle(p)),sin(getInputAngle(p))) <= -FU/2
			mo.state = S_PLAY_INFITURN
		else
			mo.state = S_PLAY_FLOAT
		end
		
		// Glow
		local ghost = P_SpawnGhostMobj(mo)
		if ghost and ghost.valid
			ghost.momx = mo.momx
			ghost.momy = mo.momy
			ghost.momz = mo.momz
			ghost.color = SKINCOLOR_RED
			ghost.colorized = true
			ghost.alpha = FU/2
		end
		
		// If Infinite hits a wall
		if P_BlockingWall(mo,mo.angle,thrust,true)
			
			// Face where you were going
			mo.angle = thrustangle
			mo.player.drawangle = mo.angle
			
			// Bounce back
			P_DoPlayerPain(p,nil,nil)
			
			// Negate the I-frames
			p.powers[pw_flashing] = 0
			
			// If you're pulling back or overclocked, bounce off a bit more gracefully
			if (dotProduct2d(cos(movingAngle),sin(movingAngle), cos(getInputAngle(p)),sin(getInputAngle(p))) <= 0)
			or p.powers[pw_super]
				S_StartSound(mo,sfx_s3k49)
				mo.state = S_PLAY_SPRING
				mo.momz = $*2
			else
				// Thud! Ow!
				S_StartSound(mo,sfx_s3k90)
				infiniteVoice(mo,hurtvox)
			end
			
			// Can't use Homing Snap after hitting a wall
			p.infinite.snapleniency = 0
			
			// Enable starting another Hover Dash after slamming into a wall while Overclocked
			if p.powers[pw_super]
				p.pflags = $|PF_JUMPED
				return 3
			end
			
			// Otherwise, let whatever script called this know that you embarassed yourself
			return 2
		end
		
		// Business as usual
		return 1
	else
		
		// Cancel the Hover Dash
		p.infinite.flighttimer = 0
		mo.state = S_PLAY_FALL
		
		// Reset what was last targeted
		mo.lastnearest = nil
		
		// You can go again in overclocked mode
		if p.powers[pw_super]
			return 3
		end
		
		// Cut momentum if you stopped early without being Overclocked
		if ~p.cmd.buttons & BT_JUMP
		and not (p.powers[pw_nocontrol]
		or p.powers[pw_carry])
			P_InstaThrust(mo,thrustangle,FixedHypot(mo.momx,mo.momy)/3)
		end
			
		// Otherwise, let whatever script called this know that we're closing up early
		return 2
	end
end

// Spawn a Tidal Wave
local spawnInfiniteMissile = function(p,mo)
	local stepz = mo.floorz
	if mo.eflags & MFE_VERTICALFLIP
		stepz = mo.ceilingz - mo.height
	end
	
	// Spawn the actual Tidal Wave object
	local missile = P_SpawnPointMissile(mo,
		mo.x + P_ReturnThrustX(nil,p.drawangle,FRACUNIT),
		mo.y + P_ReturnThrustY(nil,p.drawangle,FRACUNIT),
		stepz, MT_INFISNAKE,
		mo.x, mo.y, stepz)
		
	// Do some stuff with the Tidal Wave you just spawned
	if missile
	and missile.valid
	
		// Apply gravity flip if needed
		if mo.eflags & MFE_VERTICALFLIP
			missile.eflags = $|MFE_VERTICALFLIP
		end
		
		// Make it go
		P_Thrust(missile,missile.angle,abs(FixedHypot(mo.momx,mo.momy)))
		
		// Make its starting position match up with Infinite's animation
		P_Move(missile,32*mo.scale)
		
		// Make it your color and size
		missile.color = mo.color
		missile.scale = mo.scale
	end
	
	// Slow Infinite's movement
	if not p.powers[pw_super]
		mo.momx = $/2
		mo.momy = $/2
	end
end


-- hooks --


//Primary Infinite logic hook
addHook("PlayerThink",function(p)
	
	// No mobj, no logic
	if not (p.mo
	and p.mo.valid)
		return end
	
	// When a player switches off of Infinite mid-game, they might keep their Infinite variable table
	if p.mo.skin != "infinite"
		if p.infinite
			p.infinite = nil
		end
		return
	end
	
	// When a player switches to Infinite mid-game, the PlayerSpawn hook doesn't get a chance to initialize the Infinite variable table
	if not p.infinite
		infinitialize(p)
	end
	
	// Failsafe - this shouldn't trigger, but if it does, it'll prevent warnings later down the line
	if not p.infinite
		print("\130WARNING: \128Infinite variable table initialization failed")
	return end
	
	local mo = p.mo
	
	// Reset the Hover Dash if Infinite gets carried or touches a spring
	if p.powers[pw_justsprung]
	or p.powers[pw_carry]
	or P_IsObjectOnGround(mo)
		p.infinite.flightresolved = 0
		p.infinite.snapleniency = 0
		p.pflags = $&~ PF_THOKKED
		
	// Continue the Hover Dash
	elseif p.pflags & PF_THOKKED
	and p.infinite.flightresolved == 1
		p.infinite.flightresolved = doInfiniteFlight(p,mo)
		
	// Potentially perform a Homing Snap late
	elseif p.infinite.snapleniency
	and (p.cmd.buttons & BT_JUMP // Can be done on the ground while holding Jump...
	or not P_IsObjectOnGround(p.mo)) // ...or in the air without holding Jump
		if p.cmd.buttons & BT_SPIN
		and doInfiniteAttack(mo)
			p.infinite.flightresolved = 3
		end
		p.infinite.snapleniency = max(0,$-1)
	
	// If you aren't trying to Homing Snap, don't bother
	else
		p.infinite.snapleniency = 0
	end
	
	// Handle ending the Hover Dash
	if p.infinite.flightresolved != 1
		S_StopSoundByID(mo,sfx_inffly)
		if mo.state == S_PLAY_FLOAT
			mo.state = S_PLAY_FALL
		end
		
		// Allow the player to Hover Dash again after a Homing Snap
		if p.infinite.flightresolved == 3
		and ~p.cmd.buttons & BT_JUMP
			p.infinite.flightresolved = 0
		end
	end
	
	// Play a voice clip upon winning, but only once
	if (p.exiting
	or p.finished)
	and gametype == GT_COOP
	and mapheaderinfo[gamemap].bonustype != -1
		if not p.infinite.victorytaunt
			if novoice.value != 3
				infiniteVoice(mo,levelwin)
			end
			
			p.infinite.victorytaunt = true
		end
	else
		p.infinite.victorytaunt = false
	end
	
	// Make Infinite taunt bosses
	if p.infinite.starttaunt
		p.infinite.starttaunt = $-1
		if p.infinite.starttaunt == 0
		and novoice.value != 3
			infiniteVoice(mo,bosstaunt)
		end
	end
	
	// Handle victory animation
	if p.exiting
	and P_IsObjectOnGround(mo)
	and mapheaderinfo[gamemap].bonustype != -1
		
		// Slow down quicker
		if FixedHypot(mo.momx,mo.momy) > mo.scale
			P_InstaThrust(mo,R_PointToAngle2(0,0,mo.momx,mo.momy),max(FixedHypot(mo.momx,mo.momy)-3*mo.scale,0))
		
		// Enter victory animation state
		elseif mo.state != S_PLAY_WINFINITE
		and mo.state != S_PLAY_WINFINISH
			mo.state = S_PLAY_WINFINITE
		end
	end
	
	// Handle taunting
	if p.cmd.buttons & BT_TOSSFLAG
	and not (p.infinite.lastbuttons & BT_TOSSFLAG)
	and P_IsObjectOnGround(mo)
	and not p.infinite.manualtaunted
	and not p.weapondelay
	and not (p.exiting
	and novoice.value != 2)
	and ~gametyperules & GTR_TEAMFLAGS // Cannot be used in a gamemode where Toss Flag actually does something
		mo.state = S_PLAY_INFITAUNT
		infiniteVoice(mo,manualtaunt)
		
		// Mark the player as having taunted
		p.infinite.manualtaunted = true
		
	// Cancel the taunt if the player is in a different state
	elseif p.infinite.manualtaunted
	and mo.state != S_PLAY_INFITAUNT
	and mo.state != S_PLAY_INFITAUNT_FINISH
		p.infinite.manualtaunted = false
		if novoice.value != 2
			S_StopSoundByID(mo,sfx_ibsrta)
			S_StopSoundByID(mo,sfx_ibsrtb)
			S_StopSoundByID(mo,sfx_ibsrtc)
			S_StopSoundByID(mo,sfx_ipnchc)
			S_StopSoundByID(mo,sfx_winfic)
		end
	end
	
	// Overclocked Infinite logic
	if p.powers[pw_super]
		
		p.charflags = $|SF_SUPER // Don't get interrupted by the game thinking you're not supposed to be super
		
		// Lose rings twice as fast
		if leveltime % TICRATE == TICRATE/2
			P_GivePlayerRings(p,-1)
		end
		
		// Breathing is for losers
		p.powers[pw_underwater] = 0
		p.powers[pw_spacetime] = 0
		
		// Attract rings, if you don't have a shield that does that for you
		// (copy-pasted from another mod of mine)
		local rad = 256*mo.scale
		
		searchBlockmap("objects",function(r,f)
			// Turn rings into dropped rings
			if f.type == MT_RING
				local fling = P_SpawnMobj(f.x,f.y,f.z,MT_FLINGRING)
				if fling and fling.valid
					P_HomingAttack(fling,r)
					f.state = S_NULL
				end
				return nil
			end
			
			// Only work on rings
			if f.type != MT_FLINGRING
			and not (f.type == MT_REDTEAMRING and p.ctfteam == 1)
			and not (f.type == MT_BLUETEAMRING and p.ctfteam == 2)
				return nil end
				
			// Team rings will continue to be attracted anyway
			if f.type != MT_FLINGRING
				f.attractedTo = r
			end
				
			// Spherical hitbox. Hitball? Hit-orb?
			if FixedHypot((f.z+f.height/2)-(r.z+r.height/2),R_PointToDist2(r.x,r.y,f.x,f.y)) <= rad + f.radius
				P_HomingAttack(f,r)
			end
		end,mo,mo.x-rad,mo.x+rad,mo.y-rad,mo.y+rad)

	else
		
		// Check to see if Infinite is using the custom bind to go Overclocked
		if p.cmd.buttons & BT_CUSTOM1 // Infinite goes Overclocked using Custom 1
		and not (p.infinite.lastbuttons & BT_CUSTOM1) // Just started pressing Custom 1 on this frame (not holding it)
		and not P_IsObjectOnGround(mo)
		and p.rings >= 50
		and All7Emeralds(emeralds)
		and (p.pflags & PF_JUMPED) // You have to have jumped, rather than bouncing off a spring or such
		
			infiniteVoice(mo,levelwin) // Boast about it
			p.charflags = $|SF_SUPER // Let the game know that Infinite is, in fact, supposed to be able to go super
			p.pflags = $&~ PF_JUMPED // Can't use abilities until you land
			P_DoSuperTransformation(p)
			
		else
			p.charflags = $&~ SF_SUPER // Disable goiung super the normal way
		end
	end
	
	// Keep track of which buttons were pressed for the next frame
	p.infinite.lastbuttons = p.cmd.buttons
end)

// Set up the Infinite array
addHook("PlayerSpawn",function(p)
	if p.mo.skin != "infinite"
		p.infinite = nil
		return end
	
	infinitialize(p)

	// Make Infinite taunt bosses on level start
	if (abs(mapheaderinfo[gamemap].bonustype) == 1
	or novoice.value == 2)
	and p.realtime < TICRATE
		p.infinite.starttaunt = 1
	end
end)

// Start a Hover Dash
addHook("AbilitySpecial",function(p)
	if p.infinite
	and p.infinite.flightresolved == 0 // If the Hover Dash is not being used, and has not been used yet
		
		p.infinite.flighttimer = TICRATE*3 // The Hover Dash lasts for 3 seconds
		p.pflags = $|PF_THOKKED
		p.infinite.flightresolved = 1 // Performing Hover Dash
		S_StartSound(p.mo,sfx_inffly)
		
		// Speed up and snap movement to facing direction if Infinite is moving slowly or in the wrong direction
		local movingAngle = R_PointToAngle2(0,0,p.mo.momx,p.mo.momy)
		if FixedHypot(p.mo.momx,p.mo.momy) < 20*p.mo.scale
		or dotProduct2d(cos(movingAngle),sin(movingAngle), cos(getInputAngle(p)),sin(getInputAngle(p))) <= 0
			P_InstaThrust(p.mo,getInputAngle(p),20*p.mo.scale)
		end
		
	end
end)

// Fire off a Tidal Wave
addHook("SpinSpecial",function(p)
	
	if not (p.infinite
	and P_IsObjectOnGround(p.mo))
	or p.weapondelay > 0 // Used to keep track of when Infinite last fired one
	or p.exiting
	or p.powers[pw_nocontrol]
	or p.powers[pw_carry]
	or p.pflags & (PF_SPINNING|PF_SLIDING)
	or p.mo.state == S_PLAY_FIRE
	or p.infinite.lastbuttons & BT_SPIN
	or p.infinite.snapleniency // Can't fire a Tidal Wave if you can still Homing Snap
		return end
		
	local mo = p.mo
	p.weapondelay = TICRATE*2/3 // Delay before firing again
	
	infiniteVoice(mo,atkvox)
	infiniteRubySound(mo)
	spawnInfiniteMissile(p,mo)
	
	// Restart animation, if needed
	if mo.sprite2 == SPR2_FIRE
		mo.sprite2 = SPR2_STND
	end
	
	mo.state = S_PLAY_FIRE
	//mo.momx = $*2/3
	//mo.momy = $*2/3
end)

// Tidal Wave logic
addHook("MobjThinker", function(mo)
	// Make sure the object still exists
	--if not (mo and mo.valid) return end
	
	// Spawn 9 cubes at random sizes going in random directions
	if not mo.nocliptime
		for i = 0,32 do
			local cube = P_SpawnMobj(mo.x,mo.y,mo.z,MT_INFICUBE)
			if cube
			and cube.valid
				/*cube.scale = (FRACUNIT*3/2) - P_RandomFixed()
				cube.destscale = 0
				cube.momx = (P_RandomKey(10)*FRACUNIT/2)-(FRACUNIT*5/2)
				cube.momy = (P_RandomKey(10)*FRACUNIT/2)-(FRACUNIT*5/2)
				cube.momz = (P_RandomKey(10)*FRACUNIT/2)-(FRACUNIT*5/2)*/
				
				cube.tics = P_RandomRange(TICRATE/8,TICRATE/4)
				cube.color = mo.color
				cube.scale = FixedMul(mo.scale,P_RandomRange(FU/4,FU))
				--cube.destscale = 0
				
				cube.momx = P_RandomRange(-5,5) * mo.scale
				cube.momy = P_RandomRange(-5,5) * mo.scale
				cube.momz = P_RandomRange(0,15) * mo.scale * min(10,states[mo.state].tics - mo.tics) / 10
				P_Thrust(cube,mo.angle,-10*mo.scale)
			end
		end
	end
	
	local range = 250 * mo.scale
	
	// The conditions to target are different, so this targeting logic gets its own code
	searchBlockmap("objects",function(r,f)
		if R_PointToDist2(r.x,r.y,f.x,f.y) <= range // Within range
		and r.target != f // Don't attack the Infinite that created you
		and (not r.tracer
		or R_PointToDist2(r.x,r.y,f.x,f.y) < R_PointToDist2(r.x,r.y,r.tracer.x,r.tracer.y)) // Must be closer than what the Tidal Wave is already targeting
		and not (gametyperules & GTR_FRIENDLY
		and f.type == MT_PLAYER) // Cannot attack players in co-op
		and f.flags & MF_SHOOTABLE
		and P_IsObjectOnGround(f)
			r.tracer = f
			
			// Point towards the new target, and move at the speed it's already moving
			r.angle = R_PointToAngle2(r.x,r.y,f.x,f.y)
			P_InstaThrust(r,r.angle,FixedMul(r.scale,abs(FixedHypot(r.momx,r.momy))))
		end
	end,mo,mo.x-range,mo.x+range,mo.y-range,mo.y+range)
	
	// Break floors. Necessary to beat the game. Once again, thanks DSZ2 and ACZ1!
	if mo.floorrover
	and mo.floorrover.flags & FF_BUSTUP
		EV_CrumbleChain(mo.floorrover)
		P_ExplodeMissile(mo)
		return
	end
	
	// Figure out where the floor is
	local stepz = mo.floorz
	if mo.eflags & MFE_VERTICALFLIP
		stepz = mo.ceilingz-mo.height
	end
	
	if abs(mo.z-stepz) > MAXSTEPMOVE
	and not mo.nocliptime
		// If you hit a wall, explode
		P_ExplodeMissile(mo)
		return
	else
		// Otherwise, snap to the floor
		P_MoveOrigin(mo,mo.x,mo.y,stepz)
	end
	
	if mo.nocliptime
		mo.nocliptime = $-1
		
		if not mo.nocliptime
			// Figure out where the floor is
			stepz = mo.target.floorz
			if mo.target.eflags & MFE_VERTICALFLIP
				stepz = mo.target.ceilingz-mo.target.height
			end
			
			if abs(stepz - mo.z) > MAXSTEPMOVE
				P_KillMobj(mo)
				return
			end
			mo.flags = $&~MF_NOCLIP
		end
	else
		mo.flags = $&~MF_NOCLIP
	end
end, MT_INFISNAKE)

// Tidal Wave spawning
addHook("MobjSpawn",function(mo)
	
	// BattleMod properties
	mo.blockable = 1
	mo.block_stun = TICRATE/2
	mo.block_hthrust = 5*TICRATE
	mo.block_vthrust = 0
	mo.dontwaterslow = false
	
	// Noclip briefly to make it work in antigravity
	mo.nocliptime = 2 
	--The only way I could figure out to make Tidal Wave not spontaneously collapse in on itself 
	--when trying to use it in reverse gravity was to make it just be noclipped for a couple frames.
	--Eh, it still works better than the lava waves at the end of RVZ.
end, MT_INFISNAKE)

// Do not walls
addHook("MobjLineCollide",function(mo,line)
	return false
end,MT_INFISNAKE)

// Hurt voice clips
addHook("MobjDamage",function(mo,i,s,d,dt)
	if mo.player and mo.player.infinite
		infiniteVoice(mo,hurtvox)
	end
end, MT_PLAYER)

// Play a voice clip when defeating a boss or starting its pinch phase
addHook("MobjDamage",function(mo,i,s,d,dt)
	if novoice.value == 3
		return end // If Infinite shouldn't taunt bosses, don't taunt bosses
	if mo.flags & MF_BOSS
		if mo.health == 1
			for p in players.iterate
				// Every Infinite in the game taunts at once, which I would love to hear in a full server
				if p.infinite
					infiniteVoice(p.mo,bosswin)
				end
			end
		elseif (mo.info.damage
		and mo.health == mo.info.damage + 1)
		or novoice.value == 2
			for p in players.iterate
				if p.infinite
					infiniteVoice(p.mo,bosspinch)
				end
			end
		end
	end
end)

// Give Overclocked Infinite extra rings
addHook("MobjDamage",function(t,i,s,d,dt)
	if s and s.valid 
	and s.player and s.player.infinite
	and s.player.powers[pw_super]
		P_GivePlayerRings(s.player,2)
		S_StartSound(nil,sfx_itemup,s.player)
	end
end)

// Infinite death voice clips
addHook("MobjDeath",function(mo,i,t)
	if mo
	and mo.player
	and mo.player.infinite
		if P_RandomChance(FRACUNIT/50) // 2% chance to Say The Line, Bart
		or (novoice.value == 2 and P_RandomChance(FRACUNIT/4)) // Gets bumped up to a 25% chance in Funny Voice Mode
			infiniteStopVoice(mo)
			S_StartSound(mo,sfx_idilol)
		else
			// If the above chance fails, just play a regular hurt voice clip instead	
			infiniteVoice(mo,hurtvox)
			
			/* 
			** If anyone ever manages to get their hands on the isolated voices from
			** the pre-rendered cutscenes, please let me know. I'd love to have a
			** selection of unique voice clips for him dying.
			** "I can still fight!" "I cannot be defeated!" etc.
			** Hell, I might even make The Funny Line one of them, rather than
			** just a rare chance to happen, if I could get a version of it that
			** didn't have the music in the background.
			*/
			
		end
	end
end)

// Play a voice clip every time Infinite kills an enemy in Funny Voice Mode
addHook("MobjDeath",function(t,i,s,d,dt)
	if s
	and s.player
	and s.player.infinite
	and novoice.value == 2	
		if t.flags & MF_ENEMY
		and ~t.flags & MF_BOSS
			infiniteVoice(s,bosswin)
		elseif t.flags & MF_MONITOR
		or t.type == MT_RING
		or t.type == MT_FLINGRING
			infiniteVoice(s,levelwin)
		end
	end
end)

// Make attack sounds when jumping in Funny Voice Mode
addHook("JumpSpecial",function(p)
	if p.infinite
	and p.mo
	and novoice.value == 2
	and not p.exiting
	and P_IsObjectOnGround(p.mo)
	and p.cmd.buttons & BT_JUMP
		infiniteVoice(p.mo,atkvox)
	end
end)

// I have no clue why this was here, so I'm going to keep it commented here in case something breaks
/*addHook("PlayerCanEnterSpinGaps",function(p)
	if p.infinite
	and p.pflags & PF_THOKKED
		return false end
end)*/

// Pre-think stuff (does two mostly-unrelated things)
addHook("PreThinkFrame",function(p)
	for p in players.iterate
		if p.mo
		and p.infinite
		
			// If the Hover Dash is going, make it keep going in the same direction
			if p.infinite.flightresolved == 1
				p.infinite.prethinkthrust = R_PointToAngle2(0,0,p.mo.momx,p.mo.momy)
				
			// Otherwise, make it start in the player's action direction
			else
				p.infinite.prethinkthrust = p.mo.angle
			end
			
			// Handle input when taunting
			if p.infinite.manualtaunted
			
				// If you're slowing down or the taunt is just starting, negate directional input
				if p.speed
				or p.mo.state == S_PLAY_INFITAUNT
					p.cmd.forwardmove = 0
					p.cmd.sidemove = 0
					
				// Otherwise, cancel the taunt if there is any directional input
				elseif p.cmd.forwardmove
				or p.cmd.sidemove
					p.mo.state = S_PLAY_STND
				end
			end
		end
	end
end)

// Don't damage Infinite while he's teleporting with the Homing Snap
addHook("ShouldDamage",function(mo)
	if mo.state == S_PLAY_INFITP return false end
end,MT_PLAYER)

// Music replacement
local infiniteSuperMusic = function(p,oldname,newname,flags,loop,pos,fadeout,fadein)
	
	// Only replace super music
	if newname:lower() == "_super"
	
		// Don't let the music interrupt itself
		if oldname:lower() == "infsup"
			return true
		end
		
		// Play Infinite's super theme instead
		return "infsup"
		
	end
end

// Play Infinite's super music
addHook("MusicChange", function(oldname, newname, flags, loop, pos, fadeout, fadein)
	
	// If the local player is Infinite
	if displayplayer
	and displayplayer.infinite
		return infiniteSuperMusic(displayplayer, oldname, newname, flags, loop, pos, fadeout, fadein)
		
	// If Player 2 (splitscreen) is Infinite
	elseif secondarydisplayplayer
	and secondarydisplayplayer.infinite
		return infiniteSuperMusic(secondarydisplayplayer, oldname, newname, flags, loop, pos, fadeout, fadein)
	end
	
end)

// Make team rings continue to follow Infinite after losing Overclocked
local teamRingKeepFollow = function(mo)
	if mo.attractedTo
		if mo.attractedTo.valid
		and mo.attractedTo.player
			P_HomingAttack(mo,mo.attractedTo)
		else
			mo.attractedTo = nil
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
		end
	end
end

addHook("MobjThinker",teamRingKeepFollow,MT_REDTEAMRING)
addHook("MobjThinker",teamRingKeepFollow,MT_BLUETEAMRING)

// Vastly simplified version of AngleStand for Infinite's taunt
addHook("MobjThinker", function(mo)
	local player = mo.player
	
	if player.playerstate == PST_LIVE
	and player.infinite
	and mo and mo.valid
		local initialState = mo.state
		
		if player.infinite.prevdrawangle
			if initialState == S_PLAY_INFIMELEE_FINISH
				// Turn around after a Homing Snap
				player.drawangle = player.infinite.prevdrawangle + ANG20
				
				// If facing the same way as the camera, switch to the fall state
				if abs(player.drawangle - mo.angle) < ANG20
					player.drawangle = mo.angle
					mo.state = S_PLAY_FALL
				end
				
			elseif initialState == S_PLAY_INFITAUNT 
			or initialState == S_PLAY_INFITAUNT_FINISH
			or initialState == S_PLAY_INFIMELEE
			or initialState == S_PLAY_INFITP
			or initialState == S_PLAY_FIRE
			or initialState == S_PLAY_FIRE_FINISH
				player.drawangle = player.infinite.prevdrawangle
			end
		end
			
		player.infinite.prevdrawangle = player.drawangle -- sets the angle for the player to maintain next frame
	end
		
end, MT_PLAYER)

-- resets everything when the map changes
addHook("MapChange", function()		
	for player in players.iterate()
		player.infinite.prevdrawangle = nil
	end
end)
	
// Kirby support
if not kirbyabilitytable
	rawset(_G, "kirbyabilitytable", {}) end
kirbyabilitytable["infinite"] = 10
kirbyabilitytable[MT_INFISNAKE] = 10

// Footsteps support
if not PlayerAnimInfo
	rawset(_G, "PlayerAnimInfo", {}) end
PlayerAnimInfo["infinite"] = {
		["runFrames"] = {-1},
		["dashFrames"] = {-1},
		["walkFrames"] = {3, 7},
		["waitFrames"] = {-1},
		["milnekickFrames"] = {0, 4},
		["run"] = false,
		["dash"] = false,
		["walk"] = true,
		["idle"] = false,
		["wait"] = false,
		["milnekick"] = false,
		["superRun"] = false,
		["superDash"] = false,
		["superWalk"] = true,
		["superIdle"] = false,
		["superWait"] = false
}